//+------------------------------------------------------------------+
//|                                                    Beryozkin.mq4 |
//|                                                Tatiana Zyrianova |
//|                        https://www.mql5.com/ru/users/mqldiligent |
//+------------------------------------------------------------------+
#property copyright "Tatiana Zyrianova"
#property link      "https://www.mql5.com/ru/users/mqldiligent"
#property version   "1.00"
#property strict

enum Type {Buy, Sell};

extern double       Lots          = 0.01;       // 
extern int          TrailStart    = 15;         //  
extern int          TrailStep     = 2;          //  
extern int          TrailDistance = 10;         //  
extern Type         TypeOrder     = 0;          //  
extern string       TimeOpen      = "00:00:00"; //   
extern int          TimeTryOpen   = 30;         //    
extern int          Slippage      = 5;          // 
extern int          Magic         = 3627;       // 

int ticket;
double SL, price;
bool mdf;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   //  
   int try = 1;
   datetime OpenTime = Str_To_Time(TimeOpen);
   
   // 
   Trailing();
   
   //  
   if (CountTrades() == 0 && TimeCurrent() >= OpenTime && TimeCurrent() < OpenTime+TimeTryOpen)
   {
      if (TypeOrder == OP_BUY)  price = Ask;
      if (TypeOrder == OP_SELL) price = Bid;
      ticket = OrderSend(Symbol(), TypeOrder, Lots, price, Slippage, 0, 0, "", Magic);
   }
}
//+------------------------------------------------------------------+
int CountTrades(int type = -1)
{
   int cnt = 0;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && (OrderType() == type || type == -1))
            cnt++;
      }
   }
   return(cnt);
}
//+------------------------------------------------------------------+
datetime Str_To_Time(string str)
{
   datetime time = 0;
   datetime Zero = TimeCurrent()-(TimeHour(TimeCurrent())*3600+TimeMinute(TimeCurrent())*60+TimeSeconds(TimeCurrent()));
   time = (datetime)(Zero + StringToInteger(StringSubstr(str, 0, 2))*3600 + StringToInteger(StringSubstr(str, 3, 2))*60 + StringToInteger(StringSubstr(str, 6, 2)));
   return(time);
}
//+------------------------------------------------------------------+
void Trailing()
{   
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (OrderSelect(i, SELECT_BY_POS))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
         {
            if (OrderType() == OP_BUY)
            {
               if (Bid - OrderOpenPrice() > TrailStart*Point)
               {
                  if (OrderStopLoss() < Bid - (TrailDistance + TrailStep)*Point)
                  {
                    SL = NormalizeDouble (Bid - TrailDistance*Point, Digits);
                    if (OrderStopLoss() != SL)
                       mdf = OrderModify(OrderTicket(), OrderOpenPrice(), SL, 0, 0);
                  }
               }
            }
            if (OrderType() == OP_SELL)
            {
               if (OrderOpenPrice() - Ask > TrailStart*Point)
               {
                  if (OrderStopLoss() > Ask + (TrailDistance + TrailStep)*Point || OrderStopLoss() == 0)
                  {
                    SL = NormalizeDouble (Ask + TrailDistance*Point, Digits);
                    if (OrderStopLoss() != SL)
                       mdf = OrderModify(OrderTicket(), OrderOpenPrice(), SL, 0, 0);
                  }
               }
            }
         }
      }
   }
}